#include "Workbook.h"
#include "Worksheet.h"
#include "Cell.h"

#include <stdio.h>

using namespace FileScribe;

int main(int argc, char **argv)
{
	printf("Formula Example\n");
	printf("Create a spreadsheet with formulas!\n\n");
	
	Workbook workbook("");
	Worksheet* pWorksheet = workbook.GetWorksheetByIndex(0);
		
	for (uint16_t i = 0; i < 5; i++)
	{
		Cell* pCell = pWorksheet->GetCell(0, i);
		pCell->SetFloat(i * 2.34f);
	}

	pWorksheet->GetCell(1,0)->SetString("=SUM(A1:A5)");
	pWorksheet->GetCell(1,1)->SetString("=AVERAGE(A1:A5)");

	pWorksheet->GetCell(2,0)->SetFormula("=SUM(A1:A5)");
	pWorksheet->GetCell(2,1)->SetFormula("=AVERAGE(A1:A5)");
	
		
	workbook.Save("FormulaExample.xls");
	
	Workbook* pWorkbookIn = new Workbook("");
	if (pWorkbookIn->Load("FormulaExample.xls"))
	{
		Worksheet* pWorksheetIn = pWorkbookIn->GetWorksheetByIndex(0);
		Cell* pCellIn = pWorksheetIn->GetCell(2,1);
		printf("Formula: %s\n", pCellIn->GetFormula());
	}

	return 0;
}

