// Copyright (C) 2013 File Scribe
// All Rights Reserved.
//
// Use of this code is covered by the "NUMBER DUCK API LICENSE AGREEMENT".
// Details of this agreement are found in the file "licence.txt".
// You have permission to modify this file and use it for any purpose under the terms of
// the agreement.

#ifndef CELL_H
#define CELL_H
	#include "Export.h"

	#include <stdint.h>
	namespace FileScribe
	{
		class Worksheet;
		class Style;
		class Cell
		{
			public:
				enum Type
				{
					TYPE_EMPTY,
					TYPE_STRING,
					TYPE_FLOAT,
					TYPE_BOOLEAN,
					TYPE_FORMULA
				};

				FS_DLL bool Equals(const Cell* pCell) const;

				FS_DLL Type GetType();
				FS_DLL void Clear();

				FS_DLL void SetString(const char* szString);
				FS_DLL const char* GetString();
				//cast to string function?
				//	transform

				FS_DLL void SetFloat(double fFloat);
				FS_DLL double GetFloat();

				FS_DLL void SetBoolean(bool bBoolean);
				FS_DLL bool GetBoolean();

				FS_DLL void SetFormula(const char* szFormula);
				FS_DLL const char* GetFormula();

				FS_DLL bool SetStyle(Style* pStyle);
				FS_DLL Style* GetStyle();

			protected:
				friend class Worksheet;
				friend class BiffWorksheet;
				Cell(Worksheet* pWorksheet);
				virtual ~Cell();

				class Implementation;
				Implementation* m_pImpl;
		};
	}
#endif