// Copyright (C) 2013 File Scribe
// All Rights Reserved.
//
// Use of this code is covered by the "NUMBER DUCK API LICENSE AGREEMENT".
// Details of this agreement are found in the file "licence.txt".
// You have permission to modify this file and use it for any purpose under the terms of
// the agreement.

#ifndef CHART_H
#define CHART_H
	#include "Export.h"
	#include <stdint.h>	
	
	namespace FileScribe
	{
		class Worksheet;
		class ChartImplementation;
		class Chart
		{
			public:
				FS_DLL uint16_t GetX();
				FS_DLL bool SetX(uint16_t nX);

				FS_DLL uint16_t GetY();
				FS_DLL bool SetY(uint16_t nY);

				FS_DLL uint16_t GetSubX();
				FS_DLL void SetSubX(uint16_t nSubX);

				FS_DLL uint16_t GetSubY();
				FS_DLL void SetSubY(uint16_t nSubY);

				FS_DLL uint16_t GetWidth();
				FS_DLL void SetWidth(uint16_t nWidth);

				FS_DLL uint16_t GetHeight();
				FS_DLL void SetHeight(uint16_t nHeight);

				FS_DLL void SetFormula(const char* szFormula);
				FS_DLL const char* GetFormula();

			private:
				friend class Worksheet;
				friend class BiffWorksheet;
				
				Chart(Worksheet* pWorksheet);
				virtual ~Chart();

				ChartImplementation* m_pImpl;
		};
	}
#endif