// Copyright (C) 2013 File Scribe
// All Rights Reserved.
//
// Use of this code is covered by the "NUMBER DUCK API LICENSE AGREEMENT".
// Details of this agreement are found in the file "licence.txt".
// You have permission to modify this file and use it for any purpose under the terms of
// the agreement.

#ifndef WORKBOOK_GLOBALS_H
#define WORKBOOK_GLOBALS_H
	#include <vector>
	#include <string>
	#include <stdint.h>

	#include "Picture.h"
	namespace FileScribe
	{
		class Style;
		class WorkbookGlobals
		{
			public:
				WorkbookGlobals();
				virtual ~WorkbookGlobals();

				void Clear();

				const char* GetSharedStringByIndex(uint32_t nIndex);
				uint32_t GetSharedStringIndex(std::string sString);



				struct ImageData
				{
					Picture::Format eFormat;
					const uint8_t* pData;
					uint32_t nDataSize;
				};
				uint32_t GetImageDataIndex(Picture::Format eFormat, const uint8_t* pData, uint32_t nDataSize);

				struct WorksheetRange
				{
					uint16_t nFirst;
					uint16_t nLast;
				};
				WorksheetRange GetWorksheetRangeByIndex(uint16_t nIndex);
				uint16_t GetWorksheetRangeIndex(uint16_t nFirst, uint16_t nLast);

				uint16_t GetNumStyle();
				Style* GetStyleByIndex(uint16_t nIndex);
				Style* CreateStyle();
				uint16_t GetStyleIndex(Style* pStyle);

			protected:
				std::vector<std::string> m_sSharedStringVector;
				std::vector<ImageData> m_imageDataVector;
				std::vector<WorksheetRange> m_worksheetRangeVector;
				std::vector<Style*> m_pStyleVector;
		};
	}
#endif